Imports Microsoft.VisualBasic

Public Module Moduuli
    Public Const Ohjelmanimi As String = "RIVO"
    Public Const SarjanMaxPituus As Long = 10
    Public Const JasenenMaxPituus As Long = 20
    Public Const AakkosetString As String = " ABCDEFGHIJKLMNOPQRSTUVWXYZ" 'Vlilynti alkuun, jotta A > 0, muuten AAA = 0 = A
    Public Const Aakkosia As Long = 26
    Public Const Nulli As Long = -99499

    'TODO
    '2 sek kellotus?
    'multithread?

    Public Structure SarjaS
        Dim Jasen() As JasenS
        Dim JaseniaLaskettu As Integer
        Dim RatkaisuOK As Boolean 'Onko ratkaisu lytynyt
    End Structure

    Public Structure JasenS
        Dim Merkkijono As String 'Yhden jsenen merkkijono

        Dim Luvut() As LukujaS 'Kaikki perttiset kirjaimet, tai numerot laskettuna yhteen. A61BB = 0,61,27 (1*26+1)
        Dim Lukuja As Integer 'Montako erillist lukua jseness on, esim ylloleva = 3
    End Structure

    Public Structure LukujaS
        Dim Arvo As Long
        Dim Kirjaimia As Boolean 'Onko alkuperinen jsenen osa muodostunut kirjaimista, kuten BZ = 77

        'Muutos seuraavaan jseneen, samaan lukuun
        Dim Yhteenlasku As Long 'esim +1,+2 tai -1 on vhennyst
        Dim Kertolasku As Double 'esim *1,*2 tai *0.5 on jakolasku
    End Structure

    Function Main(ByVal args() As String) As Integer
        Dim Sarja As SarjaS
        Dim VastausSarjat(SarjanMaxPituus) As String
        Dim VastauksiaLaskettu As Integer
        Dim AlkupSarjat(SarjanMaxPituus) As String
        Dim AlkupIlmoita, AlkupJasenia, I, X, Z, Y As Integer
        Dim TiedostoRivi As Integer 'Useampirivinen debug tiedosto
        Dim KellotusAika, SuurinAika As Long

        Dim LukuTiedosto As String = Ohjelmanimi & ".LUK"
        Dim KirjoitusTiedosto As String = Ohjelmanimi & ".KIR"

        TiedostoRivi = 1

        'Listn debugconsoli ohjelmaan
        Debug.Write("")

        KirjoitaConsoliin("Ohjelma " & Ohjelmanimi & " kynnistetty.")
        KirjoitaConsoliin("Komentojono " & System.Environment.CommandLine())
        KirjoitaConsoliin("Argumentteja = " & args.Length)

        If args.Length > 0 Then 'Jos argumentti, se tarkoittaa lukutiedostoa
            KirjoitaConsoliin("Argumentti1 = " & args(0))
            LukuTiedosto = Trim(args(0))
        End If

        KirjoitaConsoliin("Suoritushakemisto " & System.Environment.CurrentDirectory())
        KirjoitaConsoliin("Lukutiedosto " & LukuTiedosto)
        KirjoitaConsoliin("Kirjotustiedosto " & KirjoitusTiedosto)
        KirjoitaConsoliin("")

        While TiedostoRivi > 0
            'Jos debug tiedosto, jossa monta rivi, lasketaan ne kaikki

            KellotusAika = System.Environment.TickCount()

            LueTiedosto(LukuTiedosto, AlkupSarjat, AlkupJasenia, AlkupIlmoita, TiedostoRivi)
            'TODO
            'Tarkista syte 0 - 9 ja A - Z (AakkosetString)
            If AlkupJasenia + AlkupIlmoita > SarjanMaxPituus Then KirjoitaConsoliin("VIRHE: Sntrike, sarjan maxpituus")
            If AlkupJasenia < 3 Then KirjoitaConsoliin("VIRHE: Sntrike, jsenten lukumr")
            If AlkupIlmoita < 1 Then KirjoitaConsoliin("VIRHE: Jsenten ilmoitusnro < 1")
            For I = 0 To AlkupJasenia - 1
                If AlkupSarjat(I).Length > JasenenMaxPituus Then KirjoitaConsoliin("VIRHE: Sntrike, jsenen maxpituus")
            Next

            For X = 0 To AlkupJasenia - 1
                VastausSarjat(X) = AlkupSarjat(X)
            Next
            VastauksiaLaskettu = AlkupJasenia

            'Lhdetn ratkaisemaan
            For I = 0 To AlkupIlmoita - 1

                'Toistoratkaisun testaus, poistamalla jseni
                'Jokainen sarja on toistuttava vhintn kerran. eli sarja AAB,123,AAB ei hyvksyt
                For Y = 1 To CInt(Int((VastauksiaLaskettu) / 2))
                    'Kokeillaan montako jsent yhdess toistossa

                    'Alustusta
                    ReDim Sarja.Jasen(SarjanMaxPituus)
                    For X = 0 To SarjanMaxPituus - 1
                        ReDim Sarja.Jasen(X).Luvut(JasenenMaxPituus)
                    Next X
                    Sarja.RatkaisuOK = False

                    X = CInt(Int((VastauksiaLaskettu) / Y))
                    Sarja.JaseniaLaskettu = X
                    'Haetaan vain jsenet joita tarvitaan, esim = J E J E J E J = E E E
                    For Z = VastauksiaLaskettu - Y To 0 Step -Y
                        Sarja.Jasen(X - 1).Merkkijono = VastausSarjat(Z)
                        X -= 1
                    Next Z

                    VastausSarjat(VastauksiaLaskettu) = RatkaiseSeuraavaJasen(Sarja)

                    If Sarja.RatkaisuOK = True Then
                        If Y > 1 Then
                            KirjoitaConsoliin(" + Toisto  = " & Y & " vlein")
                        End If
                        Exit For
                    End If
                Next Y

                If Sarja.RatkaisuOK = True Then
                    KirjoitaConsoliin("Vastaus = " & VastausSarjat(VastauksiaLaskettu))
                Else
                    'Ei ole lytyny vastausta "normaalisti"

                    'Alustusta
                    ReDim Sarja.Jasen(SarjanMaxPituus)
                    For X = 0 To SarjanMaxPituus - 1
                        ReDim Sarja.Jasen(X).Luvut(JasenenMaxPituus)
                    Next
                    Sarja.RatkaisuOK = False

                    'Kokeillaan poistaa ensimminen jsen (esim sarja E ER ERE ERER)
                    For Z = 0 To VastauksiaLaskettu - 2
                        Sarja.Jasen(Z).Merkkijono = VastausSarjat(Z + 1)
                    Next Z

                    Sarja.JaseniaLaskettu = Z
                    VastausSarjat(VastauksiaLaskettu) = RatkaiseSeuraavaJasen(Sarja)

                    If Sarja.RatkaisuOK = True Then
                        KirjoitaConsoliin("  - Eka jsen")
                        KirjoitaConsoliin("Vastaus = " & VastausSarjat(VastauksiaLaskettu))
                    Else
                        'TODO
                        'Ei ratkaisua, mits sitten

                        KirjoitaConsoliin("Ei ratkaisua. PANIC!")

                        'Koska ei saatu tt ratkaistua, ei seuraavaa hydyt edes yritt
                        For Y = 0 To AlkupIlmoita + AlkupJasenia - VastauksiaLaskettu - 1
                            'Vastaukseksi sama kuin toiseksviimeinen jsen
                            VastausSarjat(VastauksiaLaskettu) = VastausSarjat(VastauksiaLaskettu - 2)
                            VastauksiaLaskettu += 1
                            I += 1
                        Next Y
                        VastauksiaLaskettu -= 1

                    End If
                End If
                VastauksiaLaskettu += 1
            Next I

            If TiedostoRivi <> 0 Then
                'Debugluku, eli voidaan kirjoittaa muutakin tiedostoon
                For I = AlkupJasenia To VastauksiaLaskettu - 1
                    If VastausSarjat(I) <> AlkupSarjat(I) Then
                        'Merkitn vrt vastaukset
                        KirjoitaTiedostoDebug(KirjoitusTiedosto, TiedostoRivi - 1 & "Rivi : " & VastausSarjat(I) & " <> " & AlkupSarjat(I))
                        I = Nulli
                        Exit For
                    End If
                Next I
                If I <> Nulli Then
                    KirjoitaTiedostoDebug(KirjoitusTiedosto, TiedostoRivi - 1 & "Rivi : OK")
                End If
            Else
                'Kirjoitetaan .KIR tiedosto
                KirjoitaTiedosto(KirjoitusTiedosto, VastausSarjat, AlkupJasenia, VastauksiaLaskettu)
            End If

            If Sarja.RatkaisuOK = True Then
                If System.Environment.TickCount() - KellotusAika > SuurinAika Then SuurinAika = System.Environment.TickCount() - KellotusAika
                KirjoitaConsoliin("laskentaika about " & System.Environment.TickCount() - KellotusAika & "ms")
            End If

        End While

        'TODO: Debug
        'KirjoitaConsoliin("Pisin laskentaika (jossa lydetty vastaus) " & SuurinAika & "ms")
        'KirjoitaConsoliin("Ole hyv ja paina Enteri!", True)

        KirjoitaConsoliin("Nkemiin...")
        Return 0
    End Function 'Main

    'Voi laskea vain YHDEN jsenen eteenpin, koska sarja voi olla ripattu, hidasta... turhaa... hyii..
    Public Function RatkaiseSeuraavaJasen(ByRef Sarja As SarjaS) As String
        Dim I, X, Y, Z, Q As Integer
        Dim S As String

        '"Sarjoitetaan" (eritelln luvut)
        For I = 0 To Sarja.JaseniaLaskettu - 1
            MuunnaJasenLuvuiksi(Sarja.Jasen(I).Merkkijono, Sarja.Jasen(I))
        Next

        'Alustusta viel
        For I = 0 To SarjanMaxPituus - 1
            For X = 0 To JasenenMaxPituus - 1
                Sarja.Jasen(I).Luvut(X).Kertolasku = Nulli
                Sarja.Jasen(I).Luvut(X).Yhteenlasku = Nulli
            Next X
        Next I

        'Lhdetn etsimn ratkaisua
        'Tarkistetaan luvut
        For I = 0 To Sarja.JaseniaLaskettu - 2
            For X = 0 To Sarja.Jasen(I).Lukuja - 1
                If X > Sarja.Jasen(I + 1).Lukuja - 1 Then Exit For
                Sarja.Jasen(I).Luvut(X).Yhteenlasku = Sarja.Jasen(I + 1).Luvut(X).Arvo - Sarja.Jasen(I).Luvut(X).Arvo
                If Sarja.Jasen(I + 1).Luvut(X).Arvo <> 0 And Sarja.Jasen(I).Luvut(X).Arvo <> 0 Then
                    Sarja.Jasen(I).Luvut(X).Kertolasku = Sarja.Jasen(I + 1).Luvut(X).Arvo / Sarja.Jasen(I).Luvut(X).Arvo
                End If
            Next X
        Next

        For X = 0 To JasenenMaxPituus - 1
            Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Kertolasku = 1
            Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Yhteenlasku = 0
        Next X

        'Etsitn ratkaisua luvuista
        For I = 0 To Sarja.JaseniaLaskettu - 2
            For X = 0 To Sarja.Jasen(I).Lukuja - 1
                'Tarkistetaan onko muutos kokoajan sama, jos on, hyvksytn se
                If Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Yhteenlasku <> Nulli And Sarja.Jasen(I).Luvut(X).Yhteenlasku = Sarja.Jasen(I + 1).Luvut(X).Yhteenlasku Then 'And Sarja.Jasen(I).Luvut(X).Yhteenlasku <> 0 
                    Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Yhteenlasku = Sarja.Jasen(I).Luvut(X).Yhteenlasku
                Else
                    Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Yhteenlasku = Nulli
                End If
                If Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Kertolasku <> Nulli And Sarja.Jasen(I).Luvut(X).Kertolasku = Sarja.Jasen(I + 1).Luvut(X).Kertolasku And Sarja.Jasen(I).Luvut(X).Kertolasku <> 1 Then
                    Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Kertolasku = Sarja.Jasen(I).Luvut(X).Kertolasku
                Else
                    Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Kertolasku = Nulli
                End If
            Next X
        Next I

        For X = 0 To JasenenMaxPituus - 1
            Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(X).Arvo = Nulli
        Next X

        'Onko lukuratkaisu ok?
        Sarja.Jasen(Sarja.JaseniaLaskettu).Lukuja = Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Lukuja
        For I = 0 To Sarja.Jasen(Sarja.JaseniaLaskettu).Lukuja - 1
            'TODO kirjaimet huomioon, jos muuttuu vaikka jokatoinen?
            Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(I).Kirjaimia = Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Kirjaimia

            If Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Yhteenlasku <> Nulli Then
                Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(I).Arvo = Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Arvo + Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Yhteenlasku
            End If
            If Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Kertolasku <> Nulli Then
                Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(I).Arvo = CInt(Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Arvo * Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Kertolasku)
            End If
        Next I

        'Jos ei mitn muutosta, ei hyvksyt vastausta (toisto myhemmin)
        Sarja.RatkaisuOK = False
        For X = 0 To Sarja.Jasen(Sarja.JaseniaLaskettu).Lukuja - 1
            If Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Yhteenlasku <> 0 And Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(X).Kertolasku <> 1 Then
                Sarja.RatkaisuOK = True
                Exit For
            End If
        Next X
        If Sarja.RatkaisuOK = False Then
            Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(0).Arvo = Nulli
        End If

        For I = 0 To Sarja.JaseniaLaskettu - 2
            'Jos lukujen mr ei ole sama kaikissa, hyltn vastaus
            If Sarja.Jasen(I).Lukuja <> Sarja.Jasen(I + 1).Lukuja Then
                Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(0).Arvo = Nulli
            End If
        Next I

        Sarja.RatkaisuOK = True
        For X = 0 To Sarja.Jasen(Sarja.JaseniaLaskettu).Lukuja - 1
            If Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(X).Arvo = Nulli Then
                Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(X).Arvo = 0
                Sarja.RatkaisuOK = False
                Exit For
            End If
        Next X

        If Sarja.RatkaisuOK = True Then
            'Merkeiksi laskut
            For I = 0 To Sarja.Jasen(Sarja.JaseniaLaskettu).Lukuja - 1
                If Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(I).Kirjaimia = True Then
                    Sarja.Jasen(Sarja.JaseniaLaskettu).Merkkijono = Sarja.Jasen(Sarja.JaseniaLaskettu).Merkkijono & MuunnaLukuKirjaimiksi(Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(I).Arvo)
                Else
                    Sarja.Jasen(Sarja.JaseniaLaskettu).Merkkijono = Sarja.Jasen(Sarja.JaseniaLaskettu).Merkkijono & Trim(Str(Sarja.Jasen(Sarja.JaseniaLaskettu).Luvut(I).Arvo))
                End If
            Next I

            'Consoliin
            S = "  Ratkaisu = luku   "
            For I = 0 To Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Lukuja - 1
                If Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Kertolasku <> Nulli Then
                    S = S & ",*" & Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Kertolasku
                End If
                If Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Yhteenlasku <> Nulli Then
                    S = S & ",+" & Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Luvut(I).Yhteenlasku
                End If
            Next I
            KirjoitaConsoliin(S)
        End If

        'Ei ole lytynyt ratkaisua luvuista
        'Etsitn ratkaisua merkkien perusteella

        'Etsitn ratkaisua toistosta
        If Sarja.RatkaisuOK = False Then
            Sarja.RatkaisuOK = True
            For I = 0 To Sarja.JaseniaLaskettu - 2
                If Sarja.Jasen(I).Merkkijono <> Sarja.Jasen(I + 1).Merkkijono Then
                    Sarja.RatkaisuOK = False
                End If
            Next I

            If Sarja.RatkaisuOK = True Then
                Sarja.Jasen(Sarja.JaseniaLaskettu).Merkkijono = Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Merkkijono
                KirjoitaConsoliin("  Ratkaisu = toisto")
            End If
        End If

        If Sarja.RatkaisuOK = False Then
            For Z = 0 To 1000

                'Hakee jonon jostain kohtaa
                S = TapaHaeJono("A", Z, True)
                If S = "Null" Then Exit For

                For X = 0 To 1000

                    'Muuttaa jonoa jollain tapaa
                    S = TapaMuutaJono("A", X, True)
                    If S = "Null" Then Exit For

                    For Y = 0 To 1000

                        'Lis jonon johonkin kohtaan
                        S = TapaLisaaJono("A", "A", Y, True)
                        If S = "Null" Then Exit For

                        For Q = 0 To 1000
                            'Muuttaa jonoa jollain tapaa (toinen jo)
                            S = TapaMuutaJono("A", Q, True)
                            If S = "Null" Then Exit For

                            'Alustus
                            S = TapaLisaaJono("A", "A", 0, True)
                            S = TapaHaeJono("A", 0, True)

                            If 1 > Sarja.JaseniaLaskettu - 2 Then Exit For

                            For I = 0 To Sarja.JaseniaLaskettu - 2
                                S = TapaHaeJono(Sarja.Jasen(I).Merkkijono, Z)
                                S = TapaMuutaJono(S, X)
                                S = TapaLisaaJono(S, TapaMuutaJono(Sarja.Jasen(I).Merkkijono, Q), Y)
                                If S <> Sarja.Jasen(I + 1).Merkkijono Then
                                    I = Nulli
                                    Exit For
                                End If
                            Next I
                            If I <> Nulli Then
                                'Lytyi ratkaisu
                                S = TapaHaeJono(Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Merkkijono, Z)
                                S = TapaMuutaJono(S, X)
                                S = TapaLisaaJono(S, TapaMuutaJono(Sarja.Jasen(Sarja.JaseniaLaskettu - 1).Merkkijono, Q), Y)
                                Sarja.Jasen(Sarja.JaseniaLaskettu).Merkkijono = S
                                Sarja.RatkaisuOK = True
                                KirjoitaConsoliin("  Ratkaisu = tekstipohjainen" & "   ZXYQ=" & Z & " " & X & " " & Y & " " & Q)
                                Z = 1000
                                X = 1000
                                Y = 1000
                                Exit For
                            End If
                        Next Q
                    Next Y
                Next X
            Next Z
        End If

        'If Sarja.RatkaisuOK = False Then
        'viel jotain?
        'End If

        RatkaiseSeuraavaJasen = Sarja.Jasen(Sarja.JaseniaLaskettu).Merkkijono
    End Function

    Public Function TapaHaeJono(ByVal Jono As String, ByVal Tapa As Integer, Optional ByVal Eka As Boolean = False) As String
        Dim S As String
        Static Dim Mones2 As Integer
        Static Dim Entten2 As Boolean 'Tentten

        If Entten2 = True Then
            Entten2 = False
        Else
            Entten2 = True
        End If

        Mones2 += 1
        If Eka = True Then Mones2 = 0

        TapaHaeJono = "Null"
        Select Case Tapa
            Case 0 'Alusta 1 merkki
                S = Left(Jono, 1)
            Case 1 'Lopusta 1 merkki
                S = Right(Jono, 1)
            Case 2 'Keskelt 1 merkki
                If Len(Jono) > 1 Then
                    S = Mid(Jono, CInt((Len(Jono) + 0.1) / 2), 1)
                Else
                    S = Left(Jono, 1)
                End If
            Case 3 'Toisiks viimeinen merkki
                If Len(Jono) > 1 Then
                    S = Mid(Jono, Len(Jono) - 1, 1)
                Else
                    S = Right(Jono, 1)
                End If
            Case 4 'Toinen merkki
                If Len(Jono) > 1 Then
                    S = Mid(Jono, 2, 1)
                Else
                    S = Left(Jono, 1)
                End If
            Case 5 'Vapaa *************
                S = Left(Jono, 1)
            Case 6 'Alusta 2 merkki
                If Len(Jono) > 1 Then
                    S = Left(Jono, 2)
                Else
                    'Jos ei ole kahta merkki, annetaan mitsattuu jotta vastausta ei lytyisi
                    S = "F466ZX"
                End If
            Case 7 'Lopusta 2 merkki
                If Len(Jono) > 1 Then
                    S = Right(Jono, 2)
                Else
                    'Jos ei ole kahta merkki, annetaan mitsattuu jotta vastausta ei lytyisi
                    S = "F466ZX"
                End If
            Case 6 'Alusta 3 merkki
                If Len(Jono) > 2 Then
                    S = Left(Jono, 3)
                Else
                    'Jos ei ole kolmea merkki, annetaan mitsattuu jotta vastausta ei lytyisi
                    S = "F466ZX"
                End If
            Case 7 'Lopusta 3 merkki
                If Len(Jono) > 2 Then
                    S = Right(Jono, 3)
                Else
                    'Jos ei ole kolmea merkki, annetaan mitsattuu jotta vastausta ei lytyisi
                    S = "F466ZX"
                End If
            Case 8, 9 'Joka toinen alusta ja lopusta (+toinen)
                If Entten2 = True Then
                    S = Left(Jono, 1)
                Else
                    S = Right(Jono, 1)
                End If
            Case 10, 11 'X merkki
                If Mones2 = 0 Then 'alustuskierros menossa
                    S = "A"
                    Exit Select
                End If
                S = Mid(Jono, Mones2, 1)
            Case 12, 13 '-X merkki
                If Mones2 = 0 Then 'alustuskierros menossa
                    S = "A"
                    Exit Select
                End If
                If Len(Jono) - Mones2 + 1 < 1 Then
                    'Jos ei ole tarpeeksi merkkej, annetaan mitsattuu jotta vastausta ei lytyisi
                    S = "F466ZX"
                Else
                    S = Mid(Jono, Len(Jono) - Mones2 + 1, 1)
                End If
        End Select
        If Len(S) > 0 Then TapaHaeJono = S
    End Function

    Public Function TapaMuutaJono(ByVal Jono As String, ByVal Tapa As Integer, Optional ByVal Eka As Boolean = False) As String
        Dim S, B As String
        Dim I As Integer
        Static Dim Mones As Integer
        Static Dim Entten As Boolean 'Tentten
        Static Dim EnttenOhi As Boolean 'Tt functiota kutsutaan kahesti joten virityst

        If EnttenOhi = True Then
            EnttenOhi = False

            If Entten = True Then
                Entten = False
            Else
                Entten = True
            End If

            Mones += 1

        Else
            EnttenOhi = True
        End If

        If Eka = True Then Mones = 0

        TapaMuutaJono = "Null"
        Select Case Tapa
            Case 0 'Ei muutosta
                S = Jono
            Case 1 'Lisys
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) + 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) + 1)
                    End If
                Next I
            Case 2 'Vhennys
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) - 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) - 1)
                    End If
                Next I
            Case 3 'Tuplaus
                S = Jono & Jono
            Case 4 'Lisys ja tuplaus
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) + 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) + 1)
                    End If
                Next I
                S = S & S
            Case 5 'Vhennys ja tuplaus
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) - 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) - 1)
                    End If
                Next I
                S = S & S
            Case 6 'Lisys ja lismerkki
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) + 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) + 1)
                    End If
                Next I
                S = S & Right(S, 1)
            Case 7 'Vhennys ja lismerkki
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) - 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) - 1)
                    End If
                Next I
                S = S & Right(S, 1)
            Case 8 'merkkivhennys oikea
                If Len(Jono) > 1 Then
                    S = Left(Jono, Len(Jono) - 1)
                Else
                    S = Jono
                End If
            Case 9 'merkkivhennys vasen
                If Len(Jono) > 1 Then
                    S = Right(Jono, Len(Jono) - 1)
                Else
                    S = Jono
                End If
            Case 10 'Lisys ja merkkivhennys
                If Len(Jono) > 1 Then
                    For I = 1 To Len(Jono)
                        If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                            S = S & (Val(Jono.Chars(I - 1)) + 1)
                        Else
                            S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) + 1)
                        End If
                    Next I
                    S = Left(S, Len(S) - 1)
                Else
                    S = Jono
                End If
            Case 11 'Vhennys ja merkkivhennys
                If Len(Jono) > 1 Then
                    For I = 1 To Len(Jono)
                        If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                            S = S & (Val(Jono.Chars(I - 1)) - 1)
                        Else
                            S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) - 1)
                        End If
                    Next I
                    S = Left(S, Len(S) - 1)
                Else
                    S = Jono
                End If
            Case 12 'Rullaus oikealle
                If Len(Jono) > 1 Then
                    S = Right(Jono, 1) & Left(Jono, Len(Jono) - 1)
                Else
                    S = Jono
                End If
            Case 13 'Rullaus vasemmalle
                If Len(Jono) > 1 Then
                    S = Right(Jono, Len(Jono) - 1) & Left(Jono, 1)
                Else
                    S = Jono
                End If
            Case 14 'Peilaus
                If Len(Jono) > 1 Then
                    For I = 1 To Len(Jono)
                        S = Mid(Jono, I, 1) & S
                    Next I
                Else
                    S = Jono
                End If
            Case 15 'Kertominen
                For I = 1 To Mones
                    S = S & Jono
                Next
                If Len(S) < 1 Then S = Jono
            Case 16 'Kertominen +1
                For I = 0 To Mones
                    S = S & Jono
                Next
            Case 17 'Kertominen ja lisys
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) + 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) + 1)
                    End If
                Next I
                For I = 0 To Mones
                    S = S & S
                Next
            Case 18 'Kertominen +1 ja vhennys
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) - 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) - 1)
                    End If
                Next I
                For I = 0 To Mones
                    S = S & S
                Next
            Case 19 'merkkilisys oikea
                S = Jono & Right(Jono, 1)
            Case 20 'merkkilisys vasen
                S = Left(Jono, 1) & Jono
            Case 21 'Lisys 2
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) + 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) + 2)
                    End If
                Next I
            Case 23 'Vhennys 2
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) - 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) - 2)
                    End If
                Next I
            Case 22, 24 'Lisys ja vhennus vuorotellen (+toine)
                If Entten = True Then
                    For I = 1 To Len(Jono)
                        If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                            S = S & (Val(Jono.Chars(I - 1)) + 1)
                        Else
                            S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) + 1)
                        End If
                    Next I
                Else
                    For I = 1 To Len(Jono)
                        If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                            S = S & (Val(Jono.Chars(I - 1)) - 1)
                        Else
                            S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) - 1)
                        End If
                    Next I
                End If
            Case 25 'Merkkilisminen X +lisys
                If Jono = "C" And Mones > 0 Then
                    Debug.WriteLine("")
                End If
                For I = 1 To Len(Jono)
                    If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                        S = S & (Val(Jono.Chars(I - 1)) + 1)
                    Else
                        S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) + 1)
                    End If
                Next I
                For I = 0 To Mones
                    B = B & S
                Next
                S = B
                'Case 23 'Lisys 3
                '    For I = 1 To Len(Jono)
                '        If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                '            S = S & (Val(Jono.Chars(I - 1)) + 1)
                '        Else
                '            S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) + 3)
                '        End If
                '    Next I
                'Case 24 'Vhennys 3
                '    For I = 1 To Len(Jono)
                '        If Char.IsNumber(Jono.Chars(I - 1)) = True Then
                '            S = S & (Val(Jono.Chars(I - 1)) - 1)
                '        Else
                '            S = S & MuunnaLukuKirjaimiksi(MuunnaKirjaimetLuvuksi(Mid(Jono, I, 1)) - 3)
                '        End If
                '    Next I
        End Select
        If Len(S) > 0 Then TapaMuutaJono = S
    End Function

    Public Function TapaLisaaJono(ByVal Jono As String, ByVal Kohde As String, ByVal Tapa As Integer, Optional ByVal Eka As Boolean = False) As String
        Dim S As String
        Dim I As Integer
        Static Dim Mones3 As Integer
        Static Dim Entten3 As Boolean 'Tentten

        Mones3 += 1
        If Eka = True Then Mones3 = 0

        If Entten3 = True Then
            Entten3 = False
        Else
            Entten3 = True
        End If

        TapaLisaaJono = "Null"
        Select Case Tapa
            Case 0 'Loppuun
                S = Kohde & Jono
            Case 1 'Alkuun
                S = Jono & Kohde
            Case 2 'Alkuun ja loppuun
                S = Jono & Kohde & Jono
            Case 3 'Keskelle
                If Len(Kohde) > 1 Then
                    S = Left(Kohde, CInt(Int(Len(Kohde) / 2)) + 1) & Jono & Right(Kohde, CInt(Int(Len(Kohde) / 2)) + 1)
                Else
                    S = Jono & Kohde
                End If
            Case 4 'Vain jono
                S = Jono
            Case 5 'Keskelle ja reunoille
                If Len(Kohde) > 1 Then
                    'S = Jono & Left(Kohde, CInt(Int(Len(Kohde) / 2)) + 1) & Jono & Right(Kohde, CInt(Int(Len(Kohde) / 2)) + 1) & Jono
                    S = Jono & Left(Kohde, CInt(Int((Len(Kohde) + 0.1) / 2))) & Jono & Right(Kohde, CInt(Int((Len(Kohde) + 0.1) / 2))) & Jono
                Else
                    S = Jono & Kohde & Jono
                End If
            Case 6 'Alkuun (korvaa)
                If Len(Kohde) - Len(Jono) > 0 Then
                    S = Jono & Right(Kohde, Len(Kohde) - (Len(Jono)))
                Else
                    S = Jono
                End If
            Case 7 'Loppuun (korvaa)
                If Len(Kohde) - Len(Jono) > 0 Then
                    S = Left(Kohde, Len(Kohde) - (Len(Jono))) & Jono
                Else
                    S = Jono
                End If
            Case 8 'Vain Kohde
                S = Kohde
            Case 9, 10 'Joka toinen alkuun ja loppuun (+toinen)
                If Entten3 = True Then
                    S = Kohde & Jono
                Else
                    S = Jono & Kohde
                End If
            Case 11 'Keskelle ja loppuun
                If Len(Kohde) > 1 Then
                    S = Left(Kohde, CInt(Int((Len(Kohde) + 0.1) / 2))) & Jono & Right(Kohde, CInt(Int((Len(Kohde) + 0.1) / 2))) & Jono
                Else
                    S = Jono & Kohde
                End If
                'Case 12 'Alkuun + X kohdalle
                '    I = Len(Kohde) - Len(Jono) - Mones3
                '    If I < 0 Then I = 0
                '    S = Left(Kohde, Mones3) & Jono & Right(Kohde, I)
            Case 12, 13 'Alkuun + X kohdalle + siirto
                If Mones3 = 0 Then 'alustuskierros menossa
                    S = "A"
                    Exit Select
                End If
                I = Len(Kohde) - Len(Jono) - Mones3
                If I < 0 Then
                    I = 0
                    'Jos ei ole tarpeeksi merkkej, annetaan mitsattuu jotta vastausta ei lytyisi
                    S = "F466ZX"
                Else
                    S = Left(Kohde, Mones3 - 1) & Mid(Kohde & "     ", Mones3 + 1, Len(Jono)) & Jono & Right(Kohde, I)
                End If
            Case 14, 15 'Loppuun - X kohdalle + siirto
                If Mones3 = 0 Then 'alustuskierros menossa
                    S = "A"
                    Exit Select
                End If
                If Len(Kohde) - Mones3 - 1 < 0 Then
                    'Jos ei ole tarpeeksi merkkej, annetaan mitsattuu jotta vastausta ei lytyisi
                    S = "F466ZX"
                Else
                    S = Left(Kohde, Len(Kohde) - Mones3 - 1) & Jono & Mid(Kohde & "     ", Len(Kohde) - Mones3, Len(Jono)) & Right(Kohde, Mones3 - 1)
                End If
        End Select
        If Len(S) > 0 Then TapaLisaaJono = S
    End Function

    'Erottaa numerot ja kirjaimet, laskee perttiset yhteen
    Public Sub MuunnaJasenLuvuiksi(ByVal Merkkijono As String, ByRef ErotetutLuvut As JasenS)
        Dim I, X, Paikka As Integer
        Dim Luku As Boolean
        If Merkkijono.Length < 1 Then Exit Sub
        If Char.IsNumber(Merkkijono.Chars(0)) = True Then Luku = True

        'TODO, mits muuta?
        If Merkkijono.Length > 13 Then
            ErotetutLuvut.Lukuja = 1
            ErotetutLuvut.Luvut(0).Arvo = Nulli
            Exit Sub
        End If

        For I = 1 To Merkkijono.Length - 1
            If Not Luku = Char.IsNumber(Merkkijono.Chars(I)) Then
                If Luku = True Then
                    ErotetutLuvut.Luvut(X).Arvo = CInt(Val(Merkkijono.Substring(Paikka, I - Paikka)))
                    Luku = False
                Else
                    ErotetutLuvut.Luvut(X).Arvo = MuunnaKirjaimetLuvuksi(Merkkijono.Substring(Paikka, I - Paikka))
                    ErotetutLuvut.Luvut(X).Kirjaimia = True
                    Luku = True
                End If

                X += 1
                Paikka = I
            End If
        Next I
        If Luku = True Then
            ErotetutLuvut.Luvut(X).Arvo = CInt(Val(Merkkijono.Substring(Paikka, I - Paikka)))
        Else
            ErotetutLuvut.Luvut(X).Arvo = MuunnaKirjaimetLuvuksi(Merkkijono.Substring(Paikka, I - Paikka))
            ErotetutLuvut.Luvut(X).Kirjaimia = True
        End If
        ErotetutLuvut.Lukuja = X + 1
    End Sub

    '.KIR tiedoston kirjoittaminen
    Public Sub KirjoitaTiedosto(ByVal TiedostoNimi As String, ByVal Vastaukset() As String, ByVal JaseniaAnnettu As Integer, ByVal JaseniaLaskettu As Integer)
        Dim I As Integer
        KirjoitaConsoliin("Kirjoitetaan tiedosto " & TiedostoNimi)
        If IO.File.Exists(TiedostoNimi) Then
            KirjoitaConsoliin("Tiedosto " & TiedostoNimi & " oli jo olemassa. Jatketaan pern...")
        End If

        Dim Kirjoittaja As IO.StreamWriter = IO.File.AppendText(TiedostoNimi)

        For I = JaseniaAnnettu To JaseniaLaskettu - 1
            Kirjoittaja.WriteLine(Vastaukset(I))
        Next
        Kirjoittaja.Close()
    End Sub

    'Debug tiedostoon kirjoittaminen
    Public Sub KirjoitaTiedostoDebug(ByVal TiedostoNimi As String, ByVal Teksti As String)
        Dim Kirjoittaja As IO.StreamWriter = IO.File.AppendText(TiedostoNimi)
        Kirjoittaja.WriteLine(Teksti)
        Kirjoittaja.Close()
    End Sub

    '.LUK tiedoston lukeminen (jsenet saavat olla mys samalla rivill)
    Public Sub LueTiedosto(ByVal TiedostoNimi As String, ByRef Kohde() As String, ByRef Jasenia As Integer, ByRef Ilmoita As Integer, ByRef Rivi As Integer)
        Dim I, X As Integer
        KirjoitaConsoliin("Luetaan tiedostoa " & TiedostoNimi)
        If Not IO.File.Exists(TiedostoNimi) Then
            KirjoitaConsoliin("Tiedostoa " & TiedostoNimi & " ei lydy.")
            Rivi = 0
            'Todo abort?
            Exit Sub
        End If
        Dim Lukija As IO.StreamReader = IO.File.OpenText(TiedostoNimi)
        Dim Jono As String

        Jono = UCase(Trim(Lukija.ReadLine()))
        For X = 2 To Rivi
            Jono = UCase(Trim(Lukija.ReadLine()))
        Next X
        KirjoitaConsoliin(Jono)
        If Jono Is Nothing Or Len(Jono) < 1 Then KirjoitaConsoliin("VIRHE: Rivi tyhj")

        Jono = Jono & " "
        Jasenia = CInt(Val(Jono.Substring(0, Jono.IndexOf(" "))))
        If Jasenia < 1 Then KirjoitaConsoliin("VIRHE: Jsenia = " & Jasenia)
        Jono = Trim(Right(Jono, Len(Jono) - Jono.IndexOf(" "))) & " "
        Ilmoita = CInt(Val(Jono.Substring(0, Jono.IndexOf(" "))))
        If Ilmoita < 1 Then KirjoitaConsoliin("VIRHE: Ilmoita = " & Ilmoita)
        Jono = Trim(Right(Jono, Len(Jono) - Jono.IndexOf(" "))) & " "

        'Onko kaikki yhdell rivill?
        If Len(Trim(Jono)) > 0 Then
            While Not Len(Trim(Jono)) < 1
                Kohde(I) = Trim((Jono.Substring(0, Jono.IndexOf(" "))))
                Jono = Trim(Right(Jono, Len(Jono) - Jono.IndexOf(" "))) & " "
                I += 1
            End While
            Jono = UCase(Trim(Lukija.ReadLine()))
            If Len(Jono) > 0 Then
                KirjoitaConsoliin("Tiedosto jatkuu...")
                Rivi += 1
            Else
                Rivi = 0
            End If
        Else
            'Normaali rivitetty .LUK tiedosto
            Rivi = 0
            Jono = UCase(Trim(Lukija.ReadLine()))
            While Not Len(Jono) < 1
                KirjoitaConsoliin(Jono)
                Kohde(I) = Jono
                Jono = UCase(Trim(Lukija.ReadLine()))
                I += 1
            End While
        End If
        KirjoitaConsoliin("Tiedoston lukun valmis.")
        Lukija.Close()
        If I <> Jasenia Then KirjoitaConsoliin("Jseni annettu erimr, mahd debug vastauksia")
    End Sub

    'Oiskohan thn nopeampi tapa.. helppo tm ainakin on
    Public Sub MuunnaKirjaimetArvoiksi(ByVal MMerkkijono As String, ByRef MArvot() As Long)
        Dim I As Integer
        For I = 0 To MMerkkijono.Length - 1
            MArvot(I) = InStr(AakkosetString, MMerkkijono.Chars(I), CompareMethod.Text) - 1
        Next I
    End Sub
    Public Function MuunnaKirjaimetLuvuksi(ByVal MMerkkijono As String) As Long
        Dim I As Integer
        MuunnaKirjaimetLuvuksi = 0
        For I = 0 To MMerkkijono.Length - 1
            MuunnaKirjaimetLuvuksi = (MuunnaKirjaimetLuvuksi * Aakkosia) + InStr(AakkosetString, MMerkkijono.Chars(I), CompareMethod.Text) - 1
        Next I
    End Function
    Public Function MuunnaLukuKirjaimiksi(ByVal Luku As Long) As String
        MuunnaLukuKirjaimiksi = ""
        If Luku < 0 Then
            MuunnaLukuKirjaimiksi = " " 'PurkkaviritysTM
            Exit Function
        End If
        While Luku > Aakkosia - 1
            MuunnaLukuKirjaimiksi = AakkosetString.Chars(CInt(Luku Mod Aakkosia)) & MuunnaLukuKirjaimiksi
            Luku = CLng(Int(Luku / Aakkosia))
        End While
        MuunnaLukuKirjaimiksi = AakkosetString.Chars(CInt(Luku)) & MuunnaLukuKirjaimiksi
    End Function

    Public Sub KirjoitaConsoliin(ByVal Teksti As String, Optional ByVal Odota As Boolean = False)
        Static Dim AloitusAika As Long = System.Environment.TickCount()

        Console.WriteLine(System.Environment.TickCount() - AloitusAika & "ms : " & Teksti)
        If Odota = True Then
            'TODO: Vain debug vaiheessa sallittu?
            Console.ReadLine()
        End If
    End Sub
End Module