#ifndef NUMERICSOLVER_H
#define NUMERICSOLVER_H

#include "solverbase.h"

class NumericSolver : public SolverIntBase
{
	public:

		NumericSolver() {};
		~NumericSolver() {};
        bool Solve();
	    
    private:
		
		// Solvers
		bool SolveAdditional();
        bool SolveMultiply();
        bool SolveDivision();
        bool SolveFibo();        
        bool SolveDerivate();
};

#endif // NUMERICSOLVER_H
